# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class AttributeTypeUpdate(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'entity_type': 'str',
        'max_instances': 'int',
        'new_attribute_type': 'AttributeTypeUpdateNewAttributeType',
        'old_attribute_type_name': 'str'
    }

    attribute_map = {
        'entity_type': 'entity_type',
        'max_instances': 'max_instances',
        'new_attribute_type': 'new_attribute_type',
        'old_attribute_type_name': 'old_attribute_type_name'
    }

    def __init__(self, entity_type=None, max_instances=None, new_attribute_type=None, old_attribute_type_name=None, local_vars_configuration=None):  # noqa: E501
        """AttributeTypeUpdate - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._entity_type = None
        self._max_instances = None
        self._new_attribute_type = None
        self._old_attribute_type_name = None
        self.discriminator = None

        self.entity_type = entity_type
        if max_instances is not None:
            self.max_instances = max_instances
        self.new_attribute_type = new_attribute_type
        self.old_attribute_type_name = old_attribute_type_name

    @property
    def entity_type(self):
        """
        The entity type containing the attribute to rename.

        :return: The entity_type of this AttributeTypeUpdate. 
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """
        The entity type containing the attribute to rename.

        :param entity_type: The entity_type of this AttributeTypeUpdate.
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and entity_type is None:  # noqa: E501
            raise ValueError("Invalid value for `entity_type`, must not be `None`")  # noqa: E501

        self._entity_type = entity_type

    @property
    def max_instances(self):
        """
        If specified, the mutation will fail if more instances exist.

        :return: The max_instances of this AttributeTypeUpdate. 
        :rtype: int
        """
        return self._max_instances

    @max_instances.setter
    def max_instances(self, max_instances):
        """
        If specified, the mutation will fail if more instances exist.

        :param max_instances: The max_instances of this AttributeTypeUpdate.
        :type: int
        """

        self._max_instances = max_instances

    @property
    def new_attribute_type(self):
        """

        :return: The new_attribute_type of this AttributeTypeUpdate. 
        :rtype: AttributeTypeUpdateNewAttributeType
        """
        return self._new_attribute_type

    @new_attribute_type.setter
    def new_attribute_type(self, new_attribute_type):
        """

        :param new_attribute_type: The new_attribute_type of this AttributeTypeUpdate.
        :type: AttributeTypeUpdateNewAttributeType
        """
        if self.local_vars_configuration.client_side_validation and new_attribute_type is None:  # noqa: E501
            raise ValueError("Invalid value for `new_attribute_type`, must not be `None`")  # noqa: E501

        self._new_attribute_type = new_attribute_type

    @property
    def old_attribute_type_name(self):
        """
        The attribute to rename.

        :return: The old_attribute_type_name of this AttributeTypeUpdate. 
        :rtype: str
        """
        return self._old_attribute_type_name

    @old_attribute_type_name.setter
    def old_attribute_type_name(self, old_attribute_type_name):
        """
        The attribute to rename.

        :param old_attribute_type_name: The old_attribute_type_name of this AttributeTypeUpdate.
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and old_attribute_type_name is None:  # noqa: E501
            raise ValueError("Invalid value for `old_attribute_type_name`, must not be `None`")  # noqa: E501

        self._old_attribute_type_name = old_attribute_type_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AttributeTypeUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AttributeTypeUpdate):
            return True

        return self.to_dict() != other.to_dict()
