# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from tator_openapi.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    ANONYMOUSGATEWAY = "/anonymous-gateway"
    REST_AFFILIATION_ID = "/rest/Affiliation/{id}"
    REST_AFFILIATIONS_ORGANIZATION = "/rest/Affiliations/{organization}"
    REST_ALGORITHM_ID = "/rest/Algorithm/{id}"
    REST_ALGORITHM_LAUNCH_PROJECT = "/rest/AlgorithmLaunch/{project}"
    REST_ALGORITHMS_PROJECT = "/rest/Algorithms/{project}"
    REST_ANALYSES_PROJECT = "/rest/Analyses/{project}"
    REST_ANALYSIS_ID = "/rest/Analysis/{id}"
    REST_ANNOUNCEMENT_ID = "/rest/Announcement/{id}"
    REST_ANNOUNCEMENTS = "/rest/Announcements"
    REST_APPLET_ID = "/rest/Applet/{id}"
    REST_APPLETS_PROJECT = "/rest/Applets/{project}"
    REST_ATTRIBUTE_TYPE_ID = "/rest/AttributeType/{id}"
    REST_AUDIO_FILE_ID = "/rest/AudioFile/{id}"
    REST_AUDIO_FILES_ID = "/rest/AudioFiles/{id}"
    REST_AUXILIARY_FILE_ID = "/rest/AuxiliaryFile/{id}"
    REST_AUXILIARY_FILES_ID = "/rest/AuxiliaryFiles/{id}"
    REST_BOOKMARK_ID = "/rest/Bookmark/{id}"
    REST_BOOKMARKS_PROJECT = "/rest/Bookmarks/{project}"
    REST_BUCKET_ID = "/rest/Bucket/{id}"
    REST_BUCKETS_ORGANIZATION = "/rest/Buckets/{organization}"
    REST_CHANGE_LOG_PROJECT = "/rest/ChangeLog/{project}"
    REST_CLONE_MEDIA_PROJECT = "/rest/CloneMedia/{project}"
    REST_DOWNLOAD_INFO_PROJECT = "/rest/DownloadInfo/{project}"
    REST_EMAIL_PROJECT = "/rest/Email/{project}"
    REST_FAVORITE_ID = "/rest/Favorite/{id}"
    REST_FAVORITES_PROJECT = "/rest/Favorites/{project}"
    REST_FILE_ID = "/rest/File/{id}"
    REST_FILE_TYPE_ID = "/rest/FileType/{id}"
    REST_FILE_TYPES_PROJECT = "/rest/FileTypes/{project}"
    REST_FILES_PROJECT = "/rest/Files/{project}"
    REST_GET_CLIP_ID = "/rest/GetClip/{id}"
    REST_GET_CLONED_MEDIA_ID = "/rest/GetClonedMedia/{id}"
    REST_GET_FRAME_ID = "/rest/GetFrame/{id}"
    REST_IMAGE_FILE_ID = "/rest/ImageFile/{id}"
    REST_IMAGE_FILES_ID = "/rest/ImageFiles/{id}"
    REST_INVITATION_ID = "/rest/Invitation/{id}"
    REST_INVITATIONS_ORGANIZATION = "/rest/Invitations/{organization}"
    REST_JOB_UID = "/rest/Job/{uid}"
    REST_JOB_CLUSTER_ID = "/rest/JobCluster/{id}"
    REST_JOB_CLUSTERS_ID = "/rest/JobClusters/{id}"
    REST_JOBS_PROJECT = "/rest/Jobs/{project}"
    REST_LEAF_ID = "/rest/Leaf/{id}"
    REST_LEAF_COUNT_PROJECT = "/rest/LeafCount/{project}"
    REST_LEAF_TYPE_ID = "/rest/LeafType/{id}"
    REST_LEAF_TYPES_PROJECT = "/rest/LeafTypes/{project}"
    REST_LEAVES_SUGGESTION_ANCESTOR_PROJECT = "/rest/Leaves/Suggestion/{ancestor}/{project}"
    REST_LEAVES_PROJECT = "/rest/Leaves/{project}"
    REST_LOCALIZATION_ID = "/rest/Localization/{id}"
    REST_LOCALIZATION_COUNT_PROJECT = "/rest/LocalizationCount/{project}"
    REST_LOCALIZATION_GRAPHIC_ID = "/rest/LocalizationGraphic/{id}"
    REST_LOCALIZATION_TYPE_ID = "/rest/LocalizationType/{id}"
    REST_LOCALIZATION_TYPES_PROJECT = "/rest/LocalizationTypes/{project}"
    REST_LOCALIZATIONS_PROJECT = "/rest/Localizations/{project}"
    REST_MEDIA_ID = "/rest/Media/{id}"
    REST_MEDIA_COUNT_PROJECT = "/rest/MediaCount/{project}"
    REST_MEDIA_NEXT_ID = "/rest/MediaNext/{id}"
    REST_MEDIA_PREV_ID = "/rest/MediaPrev/{id}"
    REST_MEDIA_STATS_PROJECT = "/rest/MediaStats/{project}"
    REST_MEDIA_TYPE_ID = "/rest/MediaType/{id}"
    REST_MEDIA_TYPES_PROJECT = "/rest/MediaTypes/{project}"
    REST_MEDIAS_PROJECT = "/rest/Medias/{project}"
    REST_MEMBERSHIP_ID = "/rest/Membership/{id}"
    REST_MEMBERSHIPS_PROJECT = "/rest/Memberships/{project}"
    REST_MERGE_STATES_ID = "/rest/MergeStates/{id}"
    REST_NOTIFY = "/rest/Notify"
    REST_ORGANIZATION_ID = "/rest/Organization/{id}"
    REST_ORGANIZATION_UPLOAD_INFO_ORGANIZATION = "/rest/OrganizationUploadInfo/{organization}"
    REST_ORGANIZATIONS = "/rest/Organizations"
    REST_PASSWORD_RESET = "/rest/PasswordReset"
    REST_PERMALINK_ID = "/rest/Permalink/{id}"
    REST_PROJECT_ID = "/rest/Project/{id}"
    REST_PROJECTS = "/rest/Projects"
    REST_SAVE_ALGORITHM_MANIFEST_PROJECT = "/rest/SaveAlgorithmManifest/{project}"
    REST_SAVE_GENERIC_FILE_PROJECT = "/rest/SaveGenericFile/{project}"
    REST_SECTION_ID = "/rest/Section/{id}"
    REST_SECTION_ANALYSIS_PROJECT = "/rest/SectionAnalysis/{project}"
    REST_SECTIONS_PROJECT = "/rest/Sections/{project}"
    REST_STATE_ID = "/rest/State/{id}"
    REST_STATE_COUNT_PROJECT = "/rest/StateCount/{project}"
    REST_STATE_GRAPHIC_ID = "/rest/StateGraphic/{id}"
    REST_STATE_TYPE_ID = "/rest/StateType/{id}"
    REST_STATE_TYPES_PROJECT = "/rest/StateTypes/{project}"
    REST_STATES_PROJECT = "/rest/States/{project}"
    REST_TEMPORARY_FILE_ID = "/rest/TemporaryFile/{id}"
    REST_TEMPORARY_FILES_PROJECT = "/rest/TemporaryFiles/{project}"
    REST_TOKEN = "/rest/Token"
    REST_TRANSCODE_PROJECT = "/rest/Transcode/{project}"
    REST_TRIM_STATE_END_ID = "/rest/TrimStateEnd/{id}"
    REST_UPLOAD_COMPLETION_PROJECT = "/rest/UploadCompletion/{project}"
    REST_UPLOAD_INFO_PROJECT = "/rest/UploadInfo/{project}"
    REST_USER_EXISTS = "/rest/User/Exists"
    REST_USER_GET_CURRENT = "/rest/User/GetCurrent"
    REST_USER_ID = "/rest/User/{id}"
    REST_USERS = "/rest/Users"
    REST_VERSION_ID = "/rest/Version/{id}"
    REST_VERSIONS_PROJECT = "/rest/Versions/{project}"
    REST_VIDEO_FILE_ID = "/rest/VideoFile/{id}"
    REST_VIDEO_FILES_ID = "/rest/VideoFiles/{id}"
